Subject: [Webtransport] Request for Feedback: Draft Charter proposal

From: Bernard Aboba <[email-masked]>
Date: Wed, 23 Oct 2019 14:35:06 -0700

As many of you may have noticed, there will be a (non-WG forming) WEBTRANS
BOF at IETF 106:
https://trac.tools.ietf.org/bof/trac/

With the IETF 106 schedule due to be finalized soon, we are working on a
draft agenda which we hope to post to this list sometime next week.

While the upcoming IETF 106 BOF is non-WG forming, we have gotten some
feedback from the IESG  suggesting that we jumpstart discussion of a
potential WG charter.  So as to solicit feedback, we've put together an
early draft of a charter proposal, which is enclosed below.

Please note that this proposal assumes that dependencies such as work on
QUIC datagrams (e.g. draft-pauly-quic-datagram and
draft-schinazi-quic-h3-datagram  ) will be handled elsewhere, such as in a
re-chartered QUIC WG.

WebTransport (WEBTRANS)
---------------------------------------------
Charter

>
> Chairs:
>      David Schinazi <[email-masked]>
>      Bernard Aboba <[email-masked]>
>
> Applications and Real-Time Area Directors:
>      Barry Leiba <[email-masked]>
>      Alexey Melnikov <[email-masked]>
>      Adam Roach <[email-masked]>
>
> Applications and Real-Time Area Advisor:
>      Barry Leiba <[email-masked]>
>
> Mailing Lists:
>      General Discussion: [email-masked]
>      To Subscribe:
> https://www.ietf.org/mailman/listinfo/webtransport
>      Archive:
> https://mailarchive.ietf.org/arch/browse/webtransport/
>
> Description of Working Group:
>
> The WebTransport working group will define new protocols or
> protocol extensions in order to support the needs of the W3C
> WebTransport API <https://wicg.github.io/web-transport/>.
>
> These protocols will support:
>   * Reliable bidirectional and unidirectional communication
>     that provides greater efficiency than Websockets
>     (e.g. removal of head-of-line blocking).
>   * Unreliable datagram communication, functionality not
>     available in Websockets.
>   * Origin checks to allow supporting the Web's origin-based
>     security model.
>
> The WebTransport working group will define three variants:
>   * A protocol directly running over QUIC with its own ALPN.
>   * A protocol that runs multiplexed with HTTP/3.
>   * Fallback protocols that can be used when QUIC or UDP
>     is not available.
>
> The group will pay attention to security issues arising from
> the above scenarios so as to ensure against creation of new
> modes of attack, as well as to ensure that security issues
> addressed in the design of Websockets remain addressed
> in the new work.
>
> The group will coordinate with the W3C Web Incubation Community
> Group (WICG) with respect to the above deliverables to ensure the
> best possible match between the WebTransport protocol extensions
> and the W3C WebTransport API. The group will also coordinate with
> other working groups within the IETF (e.g. QUIC, HTTPBIS) as
> appropriate.
>
> Goals and Milestones:
>
>   March 2020 - Adopt a draft on WebTransport over HTTP/3 as a WG work item
>   March 2020 - Adopt a draft on WebTransport over QUIC as a WG work item
>   March 2020 - Adopt a draft on HTTP/2 fallback mechanism as a WG work item
>   March 2020 - Adopt a draft on a QUIC fallback mechanism as a WG work item
>   September 2020  - Issue WG last call on WebTransport over HTTP/3
>   September 2020  - Issue WG last call on HTTP/2 fallback mechanism
>   November 2020   - Issue WG last call on WebTransport over QUIC
>   November 2020   - Issue WG last call for QUIC fallback mechanism
>

---

From: Lucas Pardue <[email-masked]>
Date: Wed, 23 Oct 2019 14:51:36 -0700

Hi Bernard,

Thanks for sharing this.

The proposed schedule raises a question for me. It effectively gives 6
months from forming to shipping a first draft, which gives us one IETF
meeting.

With that in mind, how would you foresee the running code aspect of the
process. Would there be some opportunity to do interop such as at the
Hackathon?

I ask because I have an interest in the proposals but any implementation
activity would be from a standing start.

Cheers
Lucas

On Wed, 23 Oct 2019, 14:35 Bernard Aboba, <[email-masked]> wrote:

> https://trac.tools.ietf..org/bof/trac/
> <https://trac.tools.ietf.org/bof/trac/>
>
>>     available in Websockets..
> --
> Webtransport mailing list
> [email-masked]

---

From: Victor Vasiliev <[email-masked]>
Date: Wed, 23 Oct 2019 18:06:25 -0400

Hello Bernard,

Thanks for the charter draft!

I have a few suggestions:

   1. I think in terms of milestones, we might want to put WebTransport
   over QUIC earlier than WebTransport over HTTP/[23], since it's both simpler
   in nature and is currently under active development in Chromium.
   2. I'm not sure it would be wise to explicitly put WICG into the
   charter, as WICG expects the specs to migrate elsewhere as soon as they
   reach a certain level of maturity (so we'd need a recharter when that
   happens, which I'd prefer to avoid).

I also feel we should be somewhat more explicit about what points we expect
to coordinate with W3C (i.e. we should coordinate on requirements, but not
on protocol details).

---

From: "Martin Thomson" <[email-masked]>
Date: Thu, 24 Oct 2019 10:18:37 +1100

> WebTransport (WEBTRANS)

I don't see an explicit mention of "client to server" here, which should probably be explicit.

> >  Bernard Aboba <[email-masked]>

This decision is one for the area director, I think.

---

From: Dragana Damjanovic <[email-masked]>
Date: Thu, 24 Oct 2019 13:03:54 +0200

The charter says that it will coordinate with WICG or W3C but still has a
shipping/last call dates which are not dependent on the coordination.

Dragana

On Thu, Oct 24, 2019 at 12:06 AM Victor Vasiliev <vasilvv=
[email-masked]> wrote:

> I also feel we should be somewhat more explicit about what points we
> expect to coordinate with W3C (i.e. we should coordinate on requirements,
> but not on protocol details).
>
>> As many of you may have noticed, there will be a (non-WG forming)
>> WEBTRANS BOF at IETF 106:

---

From: Bernard Aboba <[email-masked]>
Date: Thu, 24 Oct 2019 12:27:29 -0700

Lucas said:

"With that in mind, how would you foresee the running code aspect of the
process. Would there be some opportunity to do interop such as at the
Hackathon?"

[BA] One can argue that the draft milestones are optimistic, given
experience.  So we can increase the timeline to better conform to reality.
>From the comments, it seems like the simplest work items (e.g. WebTransport
for QUIC) are likely to be implemented first; the HTTP-related items will
be likely to take longer. Having successful interop tests/Hackathon
experience will confirm that the specifications are sufficiently clear to
yield interoperable implementations.

Victor said:

"I also feel we should be somewhat more explicit about what points we
expect to coordinate with W3C (i.e. we should coordinate on requirements,
but not on protocol details)."

[BA] That is a good point.  The current Draft Charter does not include a
requirements document.  Would it make sense to add that as a work item?

---

From: Bernard Aboba <[email-masked]>
Date: Thu, 24 Oct 2019 13:33:34 -0700

Here is an updated Charter.  Is this better?

WebTransport (WEBTRANS)

Chairs:
     TBD

Mailing Lists:
     General Discussion: [email-masked]
     To Subscribe:       https://www.ietf.org/mailman/listinfo/webtransport
     Archive:
https://mailarchive.ietf.org/arch/browse/webtransport/

The WebTransport working group will define new protocols or
protocol extensions in order to support the development of the
W3C WebTransport API <https://wicg.github.io/web-transport>.

    are not available.

To assist in the coordination with W3C, the group will
initially develop an overview document containing use cases
and requirements in order to clarify the goals of the effort.
Feedback will also be solicited at various points along the way
in order to ensure the best possible match between the protocol
extensions and the needs of the W3C WebTransport API. The clarity
and interoperability of specifications will be confirmed via test
events and hackathons.

The group will also coordinate with other working groups within
the IETF (e.g. QUIC, HTTPBIS) as appropriate.

Goals and Milestones:

  March 2020     - Adopt a WebTransport Overview draft as a WG work item
  March 2020     - Adopt a draft on WebTransport over QUIC as a WG work item
  March 2020     - Adopt a draft on WebTransport over HTTP/3 as a WG work
item
  March 2020     - Adopt a draft on HTTP/2 fallback mechanism as a WG work
item
  March 2020     - Adopt a draft on a QUIC fallback mechanism as a WG work
item
  August 2020      - Issue WG last call of the WebTransport Overview
document.
  November 2020  - Issue WG last call on WebTransport over QUIC
  November 2020  - Issue WG last call on QUIC fallback mechanism
  February 2021  - Issue WG last call on WebTransport over HTTP/3
  February 2021  - Issue WG last call on HTTP/2 fallback mechanism